<template>
  <form id="form-partecipate" name="form-partecipate" @submit.prevent="onSubmit">
    <h2 class="heading heading--sec heading--branded">Participate now!</h2>

    <div class="form__row layout palm-layout--stacked" role="group">
      <input type="text" placeholder="Name" name="name" v-model="form.name" v-bind:class="{ 'invalid': isNameInvalid && form.touched.name }" @change="onChange" class="form__el layout__item">
      <input type="text" placeholder="Surname" name="surname" v-model="form.surname"  v-bind:class="{ 'invalid': isSurnameInvalid && form.touched.surname }" @change="onChange" class="form__el layout__item">
      <input type="text" placeholder="E-mail" name="email" v-model="form.email" v-bind:class="{ 'invalid': isEmailInvalid && form.touched.email }" @change="onChange" class="form__el layout__item">
    </div>

    <div class="form__row layout palm-layout--stacked" role="group">
      <input type="text" placeholder="Phone" name="phone" v-model="form.phone" v-bind:class="{ 'invalid': isPhoneInvalid && form.touched.phone }" @change="onChange" class="form__el layout__item">
      <select name="state" class="form__el layout__item">
        <option value="-">Select your state</option>
        <option value="0">Italy</option>
        <option value="1">Spain</option>
        <option value="2">France</option>
      </select>

      <date-picker></date-picker>

    </div>

    <div class="form__row layout palm-layout--stacked" role="group">
      <div class="layout__item">
        <input type="text" placeholder="Project name" name="project-name" class="form__el mb">
        <select name="project-category" id="project-category" class="form__el mb">
          <option value="-">Select a category</option>
          <option value="pro">Pro</option>
          <option value="amateur">Amateur</option>
        </select>
        <progress class="form__upload" v-if="loadingInProgress"></progress>
        <label class="form__el" for="project-upload">
          {{ fileName? fileName : "Upload your file (.jpg/.jpeg/.png)"}}
          <input type="file" name="project-upload" id="project-upload" accept=".jpg,.jpeg,.png" class="hidden" ref="fileInput" @change="onFileSelected($event)" >
        </label>
      </div>
      <textarea placeholder="Project description" maxlength="1000" name="project-desc" id="project-desc" class="form__el layout__item"></textarea>
      <div class="layout__item">
        <div class="layout layout--stacked">
          <input type="checkbox" name="read-rules" id="read-rules">
          <label for="read-rules" class="checkbox mb">
            <span class="checkbox__text">
              <a href="" class="link__deco">I read the lorem ipsum</a>
            </span>
          </label>
          <input name="privacy" type="checkbox" id="privacy" v-model="form.readPrivacy" @change="onChange">
          <label for="privacy" class="checkbox mb">
            <span class="checkbox__text" name="readPrivacy"  v-bind:class="{ 'invalid': isPrivacyInvalid }">
              <span class="link__deco" @click="togglePrivacyVisible">I read the privacy policy*</span>
            </span>
          </label>
          <aside id="privacy-info" class="privacy" v-bind:class="{ 'is-visible': isPrivacyVisible }">
            <h1 class="privacy__heading">Privacy 13 D.Lgs. 196/2003</h1>
            <p>
              Lorem ipsum dolor sit amet, consectetur adipisicing elit. Alias aliquam atque culpa, laborum, nam nisi placeat praesentium reiciendis.
            </p>
          </aside>

          <p v-if="isFormInvalid">
            <ul>
              <li v-for="error in errors" v-bind:key="error">{{ error }}</li>
            </ul>
          </p>

          <div class="btn-wrapper">
            <button type="submit" id="js-send-form" class="btn btn--main btn--full" :disabled="isFormInvalid || loadingInProgress">Submit
            </button>
          </div>

        </div>
      </div>

    </div>
  </form>
</template>

<script>
import DatePicker from "@/components/DatePicker";
const MAX_FILE_SIZE = 1024 * 1024 * 5;

export default {
  name: "PartecipateForm",
  inject: ["fileUploadService"],
  components: {
    DatePicker: DatePicker
  },
  data: function() {
    return {
      errors: [],
      loadingInProgress: false,
      isPrivacyVisible: false,
      fileName: undefined,
      form: {
        name: undefined,
        surname: undefined,
        email: undefined,
        phone: undefined,
        readPrivacy: false,
        touched: {
          name: false,
          surname: false,
          phone: false,
          email: false
        }
      }
    };
  },
  computed: {
    isFormInvalid: function() {
      return (
        this.isNameInvalid ||
        this.isSurnameInvalid ||
        this.isPhoneInvalid ||
        this.isEmailInvalid
      );
    },
    isNameInvalid: function() {
      return !this.form.name;
    },
    isSurnameInvalid: function() {
      return !this.form.surname;
    },
    isPrivacyInvalid: function() {
      return !this.form.readPrivacy;
    },
    isPhoneInvalid: function() {
      return !this.form.phone || !+this.form.phone;
    },
    isEmailInvalid: function() {
      return !this.form.email || !this.isValidMailAddress(this.form.email);
    }
  },
  methods: {
    onSubmit: function(e) {
      if (this.isPrivacyInvalid) {
        alert("You must first accept the privacy policy.");
      } else {
        alert("Project submitted");
      }
    },
    onChange: function({ type, target }) {
      this.form.touched[target.name] = true;
      this.showValidationErrors();
    },
    showValidationErrors: function() {
      this.errors = [];

      if (this.isNameInvalid && this.form.touched.name) {
        this.errors.push("The name field is required.");
      }

      if (this.isSurnameInvalid && this.form.touched.surname) {
        this.errors.push("The surname field is required.");
      }

      if (this.isEmailInvalid && this.form.touched.email) {
        this.errors.push("The email field is required.");
      }

      if (this.isPhoneInvalid && this.form.touched.phone) {
        this.errors.push("The phone field is required.");
      }
    },
    isValidMailAddress: function(email) {
      var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },
    onFileSelected: function() {
      this.fileName = undefined;

      if (this.$refs.fileInput.files[0]) {
        const file = this.$refs.fileInput.files[0];

        if (file.size <= MAX_FILE_SIZE) {
           this.fileName = file.name;
          const data = new FormData();
          data.append("file", file);

          this.loadingInProgress = true;
          this.fileUploadService.upload(data).then(
            response => {
              this.loadingInProgress = false;
            },
            errorResponse => {
              this.loadingInProgress = false;
              this.errors.push("Error uploading the file.");
            }
          );
        } else {
          alert(
            `The file size cannot be bigger than ${MAX_FILE_SIZE /
              1024 /
              1024} MB.`
          );
        }
      }
    },
    togglePrivacyVisible: function() {
      this.isPrivacyVisible = !this.isPrivacyVisible;
    }
  }
};
</script>

<style scoped lang="scss">
@import "../styles/theme.scss";
@import "../styles/breakpoints.scss";

.link__deco {
  border-bottom: 1px solid;
}

.form__upload {
  display: block;
  width: 100%;
  border: 0 none;
  color: $primary-color;
}

.form__upload::-webkit-progress-bar {
  background-color: transparent;
  border: 0 none;
}

.form__upload::-moz-progress-bar {
  background-color: transparent;
  border: 0 none;
}

.form__upload::-webkit-progress-value {
  background-color: $primary-color;
  transition: width 1s cubic-bezier(0.86, 0, 0.07, 1);
}

label[for="project-upload"] {
  transition: transform 0.1s cubic-bezier(1, 0, 0, 1);

  &:active {
    transform: scale(0.9);
  }
}

.privacy {
  color: $dark-color;
  font-size: 0.75rem;
  opacity: 0;
  transform: scale(0.9);
  transition: opacity 0.2s, transform 0.5s;
}

.privacy > p {
  margin: 0.35em 0;
}

.privacy.is-visible {
  opacity: 1;
  transform: scale(1);
}

.privacy__heading {
  font-size: 0.75rem;
  margin-bottom: 0.5em;
}
</style>